'''
spamassassin module, version 0.2

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import re,socket

def process(pf,spamstring):
    ret=[]
    exitstatus=''
    for line in pf.readlines():
      if re.search("^X-Spam-",line):
        ret.append(line)
        if re.search(spamstring,line):
          exitstatus='SPAM'
    return exitstatus,ret

class spamassassin(ascanner):
  is_spamscan=1
  name='SpamAssassin()'
  def __init__(self,arg,spamstring='^X-Spam-Level: \*\*\*\*\*',sa_max_file=500000):
      self.arg=arg
      self.SPAMSTRING=spamstring
      self.SA_MAX_FILE=sa_max_file
  def scanstream(self,stream):
      if len(stream)>self.SA_MAX_FILE:
        return '',[]
      pf=popen(self.arg)
      pf.write(stream)
      pf.close(1)
      return process(pf,self.SPAMSTRING)

class spamassassind(ascanner):
  is_spamscan=1
  name='SpamAssassind()'
  def __init__(self,arg,spamstring='^X-Spam-Level: \*\*\*\*\*',sa_max_file=500000):
      self.arg=arg
      self.SPAMSTRING=spamstring
      self.SA_MAX_FILE=sa_max_file
  def scanstream(self,stream):
      if len(stream)>self.SA_MAX_FILE:
        return '',[]
      s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      s.connect((self.arg[0],self.arg[1]))
      f=s.makefile('rw',BUFSIZE)
      s.send("PROCESS SPAMC/1.2\r\n")
      s.send("Content-length: "+str(len(stream))+"\r\n")
      s.send("User: test\r\n\r\n")
      s.send(stream)
      s.shutdown(1)
      return process(f,self.SPAMSTRING)
